/*************************************************************/
//Roll no.:-
//Program title:- Implementation of Binary Tree

#include<iostream.h>
#include<conio.h>

class bt
{

	//Structure of a node in BT
	struct node
	{
		int data;
		struct node *left;
		struct node *right;
	}*root;                    //Pointer to root node in BT

	public:
		void init();
		void insert();
		void add(node *,node *);
		void disp1();
		void disp2();
		void disp3();
		void inorder(node *);
		void preorder(node *);
		void postorder(node *);
};


//Initializing root node
void bt::init()
{
	root=NULL;
return;
}

//Inserting elements to a BT
void bt::insert()
{
	char ch1;
	do
	{
		struct node *new1;
		new1=new node;
		cout<<"\nEnter Data to insert:";
		cin>>new1->data;
		new1->left=NULL;
		new1->right=NULL;
		if(root==NULL)
		{
			root=new1;
		}
		else
		{
			add(root,new1);
		}
		cout<<"\nDo you want to insert another node:(y-yes):";
		cin>>ch1;
	}while(ch1=='y'||ch1=='Y');
return;
}

void bt::add(node *root,node *new1)
{
	char ch2;
	cout<<"\nWhere you want to insert node Left(l)/Right(r) of "<<root->data<<":";
	cin>>ch2;
	//Inserting element at Left side
	if(ch2=='l'||ch2=='L')
	{
		if(root->left==NULL)
		{
			root->left=new1;
		}
		else
		{
			add(root->left,new1);
		}
	}
	//Inserting element at right side
	if(ch2=='r'||ch2=='R')
	{
		if(root->right==NULL)
		{
			root->right=new1;
		}
		else
		{
			add(root->right,new1);
		}
	}
return;
}

void bt::disp1()
{
	if(root==NULL)
	{
		cout<<"\nTREE EMPTY";
	}
	else
	{
		inorder(root);
	}
return;
}

//Displaying contents of BT in Inorder
void bt::inorder(node *root)
{
	if(root!=NULL)
	{
		inorder(root->left);
		cout<<"\t"<<root->data;
		inorder(root->right);
	}
return;
}

void bt::disp2()
{
	if(root==NULL)
	{
		cout<<"\nTREE EMPTY";
	}
	else
	{
		preorder(root);
	}
return;
}

//Displaying contents of BT in Preorder
void bt::preorder(node *root)
{
	if(root!=NULL)
	{
		cout<<"\t"<<root->data;
		preorder(root->left);
		preorder(root->right);
	}
return;
}

void bt::disp3()
{
	if(root==NULL)
	{
		cout<<"\nTREE EMPTY";
	}
	else
	{
		postorder(root);
	}
return;
}

//Displaying contents of BT in Postorder
void bt::postorder(node *root)
{
	if(root!=NULL)
	{
		postorder(root->left);
		postorder(root->right);
		cout<<"\t"<<root->data;
	}
return;
}

void main()
{
	int ch;
	char ans;
	clrscr();
	bt b;
	b.init();
	do
	{
		cout<<"\n***Menu***";
		cout<<"\n1.Insert\n2.Inorder Display\n3.Preorder Display\n4.Postorder Display";
		cout<<"\n\nEnter Choice:";
		cin>>ch;
		switch(ch)
		{
			case 1: b.insert();
				break;
			case 2: b.disp1();
				break;
			case 3: b.disp2();
				break;
			case 4: b.disp3();
				break;
			default: cout<<"\n\nSorry...!!! Enter the Valid Choice";
		}
		cout<<"\n\nDo you want to continue:(y-yes):";
		cin>>ans;
	}while(ans=='y'||ans=='Y');
	getch();
}

/* OUTPUT :

***Menu***
1.Insert
2.Inorder Display
3.Preorder Display
4.Postorder Display

Enter Choice:1

Enter Data to insert:10

Do you want to insert another node:(y-yes):y

Enter Data to insert:5

Where you want to insert node Left(l)/Right(r) of 10:l

Do you want to insert another node:(y-yes):y

Enter Data to insert:7

Where you want to insert node Left(l)/Right(r) of 10:r

Do you want to insert another node:(y-yes):y

Enter Data to insert:15

Where you want to insert node Left(l)/Right(r) of 10:l

Where you want to insert node Left(l)/Right(r) of 5:r

Do you want to insert another node:(y-yes):y

Enter Data to insert:20

Where you want to insert node Left(l)/Right(r) of 10:r

Where you want to insert node Left(l)/Right(r) of 7:r

Do you want to insert another node:(y-yes):n

Do you want to continue:(y-yes):y

***Menu***
1.Insert
2.Inorder Display
3.Preorder Display
4.Postorder Display

Enter Choice:2
	5       15      10      7       20

Do you want to continue:(y-yes):y

***Menu***
1.Insert
2.Inorder Display
3.Preorder Display
4.Postorder Display

Enter Choice:3
	10      5       15      7       20

Do you want to continue:(y-yes):y

***Menu***
1.Insert
2.Inorder Display
3.Preorder Display
4.Postorder Display

Enter Choice:4
	15      5       20      7       10

Do you want to continue:(y-yes):n
*/