/*************************************************************/
//Roll no.:-
//Program title:- Implementation of Topological ordering on Graph using java

import java.io.*;
import java.util.*;

class Topo
{
	public int G[][],i,j,k;
	int front,rear;
	public int n,edges;
	public int b[],Q[],indegree[];
	
	public Topo(int MAX)
	{
		G=new int[MAX][MAX];
		indegree=new int[MAX];
		Q=new int [MAX];
		b=new int[MAX];
		front=rear=-1;
		for(i=0;i<MAX;i++)	//initialising graph
		{
			for(j=0;j<MAX;j++)
			{
				G[i][j]=0;
			}
		}
		for(i=0;i<MAX;i++)
		{
			indegree[i]=-99;
		}
	} //end of constructor
	
	int create()throws NullPointerException
	{
		n=5;
		edges=7;
		G[0][2]=1;
		G[0][3]=1;

		G[1][0]=1;
		G[1][3]=1;
		
		G[2][4]=1;

		G[3][2]=1;
		G[3][4]=1;

		return n;	
	}

	void Display(int n)throws NullPointerException
	{
		int v1,v2;
		for(v1=0;v1<n;v1++)
		{
			System.out.print("\n\t");
			for(v2=0;v2<n;v2++)
			{
				System.out.print("  "+G[v1][v2]);
			}
		}
	}

	void Insert_Q(int vertex,int n)throws NullPointerException
	{
		if(rear==n)
		{
			System.out.println("\nQueue overflow\n");
		}
		else
		{
			if(front==-1)  /*Empty Queue condition*/
			{
				front=0;
			}
			rear=rear+1;
			Q[rear]=vertex;  //inserting node into the Q
		}
	}

	int Delete_Q()throws NullPointerException
	{
		int item;
		if(front==-1||front>rear)
		{
			System.out.println("Queue Underflow\n");
			return-1;
		}
		else
		{
			item=Q[front];
			front=front+1;
			return item;
		}
	}
		
	int Compute_Indeg(int node,int n)throws NullPointerException
	{
		int v1,indeg_count=0;
		for(v1=0;v1<n;v1++)
		{
			if(G[v1][node]==1)  //checking for incoming edges
			{
				indeg_count++;
			}
		}
		return indeg_count++;
	}

	void Topo_ordering(int n)
	{
		j=0;
		for(i=0;i<n;i++)
		{
			indegree[i]=Compute_Indeg(i,n);
			if(indegree[i]==0)
			{
				Insert_Q(i,n);
			}
		}
		while(front<=rear)
		{
			k=Delete_Q();
			b[j+1]=k;
			for(i=0;i<n;i++)
			{
				if(G[k][i]==1)
				{
					G[k][i]=0;
					indegree[i]=indegree[i]-1;
					if(indegree[i]==0)
						Insert_Q(i,n);
				}
			}
		}
		System.out.println("\nThe result after topological sorting is.....");
		for(i=0;i<n;i++)
			System.out.println(" "+b[i]);
		System.out.println("\n");
	}
} // end of class

class mainclass
{
	public static void main(String[] args) throws IOException,NullPointerException
	{
		int edges,v1,v2;
		Topo obj=new Topo(10);
		obj.n=obj.create();
		System.out.println("\nThe Adjecency matrix is :");
		obj.Display(obj.n);
		obj.Topo_ordering(obj.n);
	}
}

/*OUTPUT:

The Adjecency matrix is :

	  0  0  1  1  0
	  1  0  0  1  0
	  0  0  0  0  1
	  0  0  1  0  1
	  0  0  0  0  0
The result after topological sorting is.....
 0
 4
 0
 0
 0
*/
